" FILE: Lgrep.vim
" AUTHOR:  yuratomo
" Last Modified: 06 Feb 2012.
" Version: 0.0.2

if exists('g:Lgrep_loaded') && g:Lgrep_loaded == 1
  finish
endif
if !exists('g:Lgrep#AutoUpdateQuickFix')
  let g:Lgrep#AutoUpdateQuickFix=1
endif

command! -nargs=* Lgrep :call Lgrep#DoGrep(<f-args>)
command! -nargs=0 LgrepUpdate :call Lgrep#UpdateQuickFix()
command! -nargs=0 LgrepCancel :call Lgrep#CancelGrep()

function! Lgrep#DoGrep(...)
  let g:Lgrep#temp_file=tempname()
  silent exe '!start /MIN cmd /c TITLE Lgrep'.v:servername.' & findstr /n '.join(a:000,' ').'>'.g:Lgrep#temp_file.' & '.$vim.'\gvim --cmd "call remote_expr('."'".v:servername."','"."GrepPostProc()"."'".')" --cmd ":q" --'
endfunction

function! GrepPostProc()
  if exists('g:Lgrep#temp_file')
    echo "find ".split(tr(system('find /C /V "" '.g:Lgrep#temp_file),"\n",' '),' ')[2]." items."
  endif
  if g:Lgrep#AutoUpdateQuickFix==1
    call Lgrep#UpdateQuickFix()
  endif
endfunction

function! Lgrep#UpdateQuickFix()
  if exists('g:Lgrep#temp_file')
    exe 'cgetfile '.g:Lgrep#temp_file
    cw
  endif
endfunction

function! Lgrep#CancelGrep()
  silent exe '!start /b cmd /c taskkill /T /F /Fl "WINDOWTITLE eq Lgrep'.v:servername.'" & taskkill /T /F /Fl "WINDOWTITLE eq Ǘ:  Lgrep'.v:servername.'*"'
endfunction

let g:Lgrep_loaded = 1
